////////////////////////////////////////////////////////////////////////////////
//                                                                            // 
//                     Copyright (C) 2004 Duc-Phuong Nguyen                   //
//                                                                            //
//      class of potential in three directions with constant cylinders        //
//                                                                            //
//                        last modification : 04/22/2004                      //
//                                                                            //
//                                                                            //
//    This program is free software; you can redistribute it and/or modify    //
//    it under the terms of the GNU General Public License as published by    //
//    the Free Software Foundation; either version 2 of the License, or       //
//    (at your option) any later version.                                     //
//                                                                            //
//    This program is distributed in the hope that it will be useful,         //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of          //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           //
//    GNU General Public License for more details.                            //
//                                                                            //
//    You should have received a copy of the GNU General Public License       //
//    along with this program; if not, write to the Free Software             //
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


#include "Tools/QuantumDot/Potential/ThreeDConstantCylinderPotential.h"

#include <iostream>
#include <fstream>
#include <stdlib.h>

using std::cout;
using std::endl;
using std::ofstream;
using std::ifstream;


// destructor
//

ThreeDConstantCylinderPotential::~ThreeDConstantCylinderPotential()
{
  delete[] this->PotentialValue;
}

// shift the potential with a given quantity
//
// delta = shift value

void ThreeDConstantCylinderPotential::ShiftPotential(double delta)
{
  for (int k = 0; k < this->NumberZ; ++k)
    this->PotentialValue[k] += delta;
}

// save the diagram of atoms in a file
//
// fileName = name of the file to stock the diagram

void ThreeDConstantCylinderPotential::SaveDiagram(char* fileName)
{
}

// load the diagram of atoms from a file
//
// fileName = name of the file in which the diagram is stocked

void ThreeDConstantCylinderPotential::LoadDiagram(char* fileName)
{
}

// save the potential in a file
//
// fileName = name of the file to stock the potential
// the file contains NumberZ blocks, each block has NumberY lines and NumberX columns

void ThreeDConstantCylinderPotential::SavePotential(char* fileName)
{
}

// load the potential from a file
//
// fileName = name of the file in which the potential is stocked

void ThreeDConstantCylinderPotential::LoadPotential(char* fileName)
{
}
